<?php
/**
 * Power by 湖北巨量云科技有限公司
 * Author: xiaohuoban
 * Create Date: 2021/10/23 5:24 下午
 *
 */
require_once ('src/api/Common.php');
require_once ('src/utils/ResponseKit.php');
require_once ('src/utils/HttpKit.php');
require_once ('src/utils/SignKit.php');


class Unlimited {

    // 业务编号
    private string $trade_no;
    // 业务密钥
    private string $key;
    // 提取数量
    private int $num;

    /**
     * 提取动态IP
     */
    CONST GET_IPS_ACTION = "UNLIMITED_GET_IPS";

    /**
     * 设置IP白名单
     */
    CONST SET_WHITE_IP_ACTION = "UNLIMITED_SET_WHITE_IP";

    /**
     * 获取IP白名单
     */
    CONST GET_WHITE_IP_ACTION = "UNLIMITED_GET_WHITE_IP";

    /**
     * 替换IP白名单
     */
    CONST REPLACE_WHITE_IP_ACTION = "UNLIMITED_REPLACE_WHITE_IP";


    /**
     * 获取动态代理信息初始化
     * @param string $trade_no
     * @param int $num
     * @param string $key
     */
    public function __construct(string $trade_no, int $num, string $key)
    {
        $this->trade_no = $trade_no;
        $this->num = $num;
        $this->key = $key;
    }

    /**
     * 执行操作
     * @param string $action
     * @param array $params
     * @param string $requestMethod
     * @return mixed|void
     */
    public function action(string $action, array $params = [], string $requestMethod = "GET")
    {
        // 获取对应Api
        $apiUrl = Common::getApiUrl($action);
        if (empty($apiUrl)) {
            return ResponseKit::apiReturn(['code' => 400, 'msg' => "暂不支持此操作，请参照代码示例修改"]);
        }
        $params['trade_no'] = $this->trade_no;
        $params['num']  = $this->num;
        $params['sign'] = SignKit::md5Sign($params, $this->key);
        $getIpsResult = HttpKit::sendRequest($apiUrl, $params, $requestMethod);
        if (true === $getIpsResult['ret']) {
            return $getIpsResult['data'];
        }
        return ResponseKit::apiReturn(['code' => 400, 'msg' => $getIpsResult['msg']]);
    }




}
