<?php
/**
 * Power by 湖北巨量云科技有限公司
 * Author: xiaohuoban
 * Create Date: 2021/10/23 5:45 下午
 *
 */
require_once ('src/api/Common.php');
require_once ('src/utils/ResponseKit.php');
require_once ('src/utils/HttpKit.php');
require_once ('src/utils/SignKit.php');



class Users {

    /**
     * @var int 用户ID
     */
    private int $userId;
    /**
     * @var string 用户密钥
     */
    private string $key;
    /**
     * 获取账户余额
     */
    CONST GET_BALANCE_ACTION = "USER_GET_BALANCE";

    public function __construct($userId, $key)
    {
        $this->userId = $userId;
        $this->key = $key;
    }

    /**
     * 执行操作
     * @param string $action
     * @param array $params
     * @param string $requestMethod
     * @return mixed|void
     */
    public function action(string $action, array $params = [], string $requestMethod = "GET")
    {
        // 获取对应Api
        $apiUrl = Common::getApiUrl($action);
        if (empty($apiUrl)) {
            return ResponseKit::apiReturn(['code' => 400, 'msg' => "暂不支持此操作，请参照代码示例修改"]);
        }
        $params['user_id'] = $this->userId;
        $params['sign'] = SignKit::md5Sign($params, $this->key);
        $getIpsResult = HttpKit::sendRequest($apiUrl, $params, $requestMethod);
        if (true === $getIpsResult['ret']) {
            return $getIpsResult['data'];
        }
        return ResponseKit::apiReturn(['code' => 400, 'msg' => $getIpsResult['msg']]);
    }

}